(* equality_commented.ml: show differences in how = and == work. Commented
   version in euqality_commented.ml *)

open Printf;;

type myrec = {s : string; i : int};;

let _ =
  let a = 5 in
  let b = 5 in
  let c = a in
  printf "---ints---\n";
  printf "a=b  : %b\n" (a=b);         (* a=b  : true *)
  printf "a==b : %b\n" (a==b);        (* a==b : true *)
  printf "a=c  : %b\n" (a=c);         (* a=c  : true *)
  printf "a==c : %b\n" (a==c);        (* a==c : true *)

  let x = ref 5 in
  let y = ref 5 in
  let z = x in
  printf "---int Refs---\n";
  printf "x=y  : %b\n" (x=y);         (* x=y  : true *)
  printf "x==y : %b\n" (x==y);        (* x==y : fals *)
  printf "x=z  : %b\n" (x=z);         (* x=z  : true *)
  printf "x==z : %b\n" (x==z);        (* x==z : true *)

  let s = "hi" in
  let t = "hi" in
  let u = s in
  printf "---Strings---\n";
  printf "s=t  : %b\n" (s=t);
  printf "s==t : %b\n" (s==t);
  printf "s=u  : %b\n" (s=u);
  printf "s==u : %b\n" (s==u);

  let f = {s="yo"; i=2} in
  let g = {s="yo"; i=2} in
  let h = f in
  printf "---Records---\n";
  printf "f=g  : %b\n" (f=g);
  printf "f==g : %b\n" (f==g);
  printf "f=h  : %b\n" (f=h);
  printf "f==h : %b\n" (f==h);
;;

